<script setup lang="ts">
import { computed, onMounted, ref, watch } from "vue";
import type { ExtendedColors, SizeModifierType } from "@/types/PropTypes";

const model = defineModel({ required: true });

const props = defineProps<{
  required?: boolean;
  sizeModifier?: SizeModifierType;
  border?: ExtendedColors;
  mapping: Record<string, string | number>;
  allowRaw?: boolean;
  id: string;
  customValidity?: string;
}>();

const emit = defineEmits<{
  (e: "switch-to-raw"): void;
}>();

watch(
  () => props.customValidity,
  (newVal, oldVal) => {
    if (newVal != oldVal) {
      enumSelect.value?.setCustomValidity(newVal ?? "");
    }
  },
);

const enumSelect = ref<HTMLSelectElement | undefined>(undefined);

const dynamicCssClasses = computed<string[]>(() => {
  const cssClasses = [];
  if (props.sizeModifier) {
    cssClasses.push(`form-select-${props.sizeModifier}`);
  }
  if (props.border) {
    cssClasses.push("border", `border-${props.border}`);
  }
  return cssClasses;
});

onMounted(() => {
  enumSelect.value?.setCustomValidity(props.customValidity ?? "");
});
</script>

<template>
  <select
    :id="id"
    ref="enumSelect"
    v-model="model"
    class="form-select"
    :class="dynamicCssClasses"
    :required="required"
  >
    <option
      v-for="(val, paramOption) in mapping"
      :key="paramOption"
      :value="val"
    >
      {{ paramOption }}
    </option>
  </select>
  <button
    v-if="allowRaw"
    type="button"
    class="btn btn-outline-secondary"
    @click="emit('switch-to-raw')"
  >
    Raw
  </button>
</template>

<style scoped></style>
